﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Windows.Forms.DataVisualization.Charting;
using System.Diagnostics;
using System.Threading;

namespace Simulace_membrenovych_proudu
{
    public partial class App : Form
    {
        public App()
        {
            InitializeComponent();
        }
        double gNa = 23.0; // milisiemens/µF
        double gCa = 0.09; // milisiemens/µF
        double gK = 0.282; // milisiemens/µF
        double gK1 = 0.6047; // milisiemens/µF
        double gto = 0.0688; // milisiemens/µF
        double ENa = 54.4; //mV
        double EK = -77; //mV
        double EK1 = -87.26; //mV
        double EKp = -87.26; //mV
        double ECa = -82.3 - 13.0287 * Math.Log(2e-4); //mV
        double Ca = 2e-4;
        void vypocet1() //voltage clamp
        {
            if (setvolt.Checked == true)
            {
                if (double.Parse(timey.Text) > 1500)
                {
                    timey.Text = "1500";
                    MessageBox.Show("Max lenght of mesuring is 1500");
                }
            }
            if (double.Parse(from.Text) < -86)
            {
                from.Text = "-86";
                MessageBox.Show("It is too low voltage. Min value of voltage is -86");
            }
            progressBar1.Minimum = 0;
            progressBar1.Maximum = 3;
            progressBar2.Minimum = 0;
            progressBar2.Maximum = 3;
            progressBar1.Value = 1;
            progressBar2.Value = 1;
            graf.Series.Clear();
            progressBar1.Value = 2;
            progressBar2.Value = 2;
            graf.Series.Clear();
            progressBar1.Value = 3;
            progressBar2.Value = 3;
            double U = double.Parse(from.Text);
            double pokusx = 0;
            double pokussy = 1.2;
            graf.Series.Add("Proud 1");
            graf.Series["Proud 1"].ChartType = SeriesChartType.FastLine;
            graf.Series["Proud 1"].Color = Color.DarkSlateGray;
            graf.Series["Proud 1"].BorderWidth = 2;
            graf.Series.Add("Proud 2");
            graf.Series["Proud 2"].ChartType = SeriesChartType.FastLine;
            graf.Series["Proud 2"].Color = Color.Navy;
            graf.Series["Proud 2"].BorderWidth = 2;
            graf.Series.Add("Proud 3");
            graf.Series["Proud 3"].ChartType = SeriesChartType.FastLine;
            graf.Series["Proud 3"].Color = Color.Green;
            graf.Series["Proud 3"].BorderWidth = 2;
            graf.Series.Add("Proud 4");
            graf.Series["Proud 4"].ChartType = SeriesChartType.FastLine;
            graf.Series["Proud 4"].Color = Color.DarkGoldenrod;
            graf.Series["Proud 4"].BorderWidth = 2;
            graf.Series.Add("Proud 5");
            graf.Series["Proud 5"].ChartType = SeriesChartType.FastLine;
            graf.Series["Proud 5"].Color = Color.Orange;
            graf.Series["Proud 5"].BorderWidth = 2;
            graf.Series.Add("Proud 6");
            graf.Series["Proud 6"].ChartType = SeriesChartType.FastLine;
            graf.Series["Proud 6"].Color = Color.DarkBlue;
            graf.Series["Proud 6"].BorderWidth = 2;
            graf.Series.Add("Proud 8");
            graf.Series["Proud 8"].ChartType = SeriesChartType.FastLine;
            graf.Series["Proud 8"].Color = Color.DarkRed;
            graf.Series["Proud 8"].BorderWidth = 2;
            graf.Series.Add("osy");
            graf.Series["osy"].ChartType = SeriesChartType.FastLine;
            graf.Series["osy"].Color = Color.Transparent;
            graf.Series.Add("Napeti 1");
            graf.Series["Napeti 1"].ChartType = SeriesChartType.FastLine;
            graf.Series["Napeti 1"].Color = Color.DarkGreen;
            graf.Series["Napeti 1"].ChartArea = graf.ChartAreas[1].Name;
            graf.Series["Napeti 1"].BorderWidth = 2;
            graf.Series.Add("osy2");
            graf.Series["osy2"].ChartType = SeriesChartType.FastLine;
            graf.Series["osy2"].Color = Color.Transparent;
            graf.Series["osy2"].ChartArea = graf.ChartAreas[1].Name;
            graf.ChartAreas[0].AxisX.Title = "Time [ms]";
            graf.ChartAreas[0].AxisY.Title = "Current [μA]";
            graf.ChartAreas[1].AxisX.Title = "Time [ms]";
            graf.ChartAreas[1].AxisY.Title = "Voltage [mV]";
            double alfam = 0.32 * (U + 47.13) / (1 - Math.Exp(-0.1 * (U + 47.13)));
            double betam = 0.08 * Math.Exp(-U / 11.0);
            //double alfah = 0.5 * (1 - Math.Sign(U + 40 + Math.Pow(2, -52))) * 0.135 * Math.Exp(-1 * (80 + U) / 6.8);
            //double betah = (3.56 * Math.Exp(0.079 * U) + 3.1 * 1e5 * Math.Exp(0.35 * U)) * 0.5 * (1 - Math.Sign(U + 40 + Math.Pow(2, -52))) + (1 / (0.13 * (1 + Math.Exp(-1 * (U + 10.66) / 11.1)))) * 0.5 * (1 + Math.Sign(U + 40 + Math.Pow(2, -52)));
            double alfah = 0.135 * Math.Exp((80 + U) / (-6.8));
            double betah = 3.56 * Math.Exp(0.079 * U) + 3.1 * 100000 * Math.Exp(0.35 * U);
            double alfaj = (-1.2714 * 100000 * Math.Exp(0.2444 * U) - 3.474 * 1000000 * Math.Exp(-0.04391 * U)) * (U + 37.78) / (1 + Math.Exp(0.311 * (U + 79.23)));
            double betaj = 0.1212 * Math.Exp(-0.01052 * U) / (1 + Math.Exp(-0.1378 * (U + 40.14)));
            //double alfaj = 0.5 * (1 - Math.Sign(U + 40 + Math.Pow(2, -52))) * (-1.2714 * 1e5 * Math.Exp(0.2444 * U) - 3.474 * 1e-5 * Math.Exp(-0.04391 * U)) * (U + 37.78) / (1 + Math.Exp(0.311 * (U + 79.23)));
            //double betaj = 0.5 * (1 - Math.Sign(U + 40 + Math.Pow(2, -52))) * 0.1212 * Math.Exp(-0.01052 * U) / (1 + Math.Exp(-0.1378 * (U + 40.14))) + 0.5 * (1 + Math.Sign(U + 40 + Math.Pow(2, -52))) * 0.3 * Math.Exp(-2.535 * 1 * Math.Exp(-7) * U) / (1 + Math.Exp(-0.1 * (U + 32)));
            double alfad = 0.095 * Math.Exp(-0.01 * (U - 5)) / (1 + Math.Exp(-0.072 * (U - 5)));
            double betad = 0.07 * Math.Exp(-0.017 * (U + 44)) / (1 + Math.Exp(0.05 * (U + 44)));
            double alfaf = 0.012 * Math.Exp(-0.008 * (U + 28)) / (1 + Math.Exp(0.15 * (U + 28)));
            double betaf = 0.0065 * Math.Exp(-0.02 * (U + 30)) / (1 + Math.Exp(-0.2 * (U + 30)));
            double alfax = 0.0005 * Math.Exp(0.083 * (U + 50)) / (1 + Math.Exp(0.057 * (U + 50)));
            double betax = 0.0013 * Math.Exp(-0.06 * (U + 20)) / (1 + Math.Exp(-0.04 * (U + 20)));
            double alfak1 = 1.02 / (1 + Math.Exp(0.2385 * (U - EK1 - 59.2915)));
            double betak1 = (0.49124 * Math.Exp(0.08032 * (U - EK1 + 5.476)) + Math.Exp(0.06175 * (U - EK1 - 594.31))) / (1 + Math.Exp(-0.5143 * (U - EK1 + 4.753)));

            double V = (pokusx - 1) * 20;
            double alfa = Math.Exp(-0.0220741 * (V + 386.9));
            double beta = Math.Exp(0.052 * (V - 73.08));
            double y = alfa / (alfa + beta);

            double m = alfam / (alfam + betam);
            double h = alfah / (alfah + betah);
            double j = alfaj / (alfaj + betaj);
            double d = alfad / (alfad + betad);
            double f = alfaf / (alfaf + betaf);
            double x = alfax / (alfax + betax);
            double dt = 0.01;
            double pommax = 0;
            double pommin = 0;
            int bar = 0;
            int time = 0;
            double Time = 0;
            if (setvolt.Checked == true)
            {
                time = int.Parse(timey.Text);
                Time = double.Parse(timey.Text);
            };
            if (setvolt.Checked == false)
            {
                time = int.Parse(textBox3.Text) * 3 + int.Parse(textBox2.Text);
                Time = double.Parse(textBox3.Text) * 3 + double.Parse(textBox2.Text);
            };
            progressBar1.Minimum = 0;
            progressBar1.Maximum = (time * 100);
            progressBar2.Minimum = 0;
            progressBar2.Maximum = (time * 100);
            for (double i = 0; i < (Time * 100); i++)
            {
                progressBar1.Value = bar;
                progressBar2.Value = bar;
                bar++;
                //double xi = 2.837 * (Math.Exp(0.04*(U + 77)) - 1) / ((V + 77) * Math.Exp(0.04*(U + 35)));
                double xi = 0.5 * (1 + Math.Sign(U + 100 - (2.2204 * Math.Pow(10, -16)))) * 2.837 * (Math.Exp(0.04 * (U + 77)) - 1) / ((U + 77) * Math.Exp(0.04 * (U + 35))) + 0.5 * (1 - Math.Sign(U + 100 - (2.2204 * Math.Pow(10, -16))));
                double INa = (gNa * (Math.Pow(m, 3)) * h * j * (U - ENa));
                double INax = INa / 50;
                double ICa = gCa * d * f * (U - ECa);
                double IK = gK * x * xi * (U - EK);
                double IK1 = gK1 * (alfak1 / (alfak1 + betak1)) * (U - EK1);
                double IKp = 0.0183 * (U - EKp) / (1 + Math.Exp((7.488 - U) / 5.98));
                double Ibg = 0.03921 * (U + 59.87);
                double Ito = gto * m * h * Math.Exp(U / 300) * (U - EK);
                double Im = INa + ICa + IK + IK1 + IKp + Ibg + Ito;
                double Imx = INax + ICa + IK + IK1 + IKp + Ibg + Ito;

                double If = y * y * 0.2182 * (V + 24);
                double tau = 1 / (alfa + beta);
                double inf = alfa / (alfa + beta);
                double dy = (inf - y) / tau;
                y = y + 0.01 * dy;
                alfa = Math.Exp(-0.0220741 * (V + 386.9));
                beta = Math.Exp(0.052 * (V - 73.08));

                Ca = Ca + dt * ((-10e-7) * ICa + 0.07 * ((10e-7) - Ca));
                ECa = -82.3 - 13.0287 * Math.Log(Ca);

                double taum = 1 / (alfam + betam);
                double infm = alfam / (alfam + betam);
                double tauh = 1 / (alfah + betah);
                double infh = alfah / (alfah + betah);
                double tauj = 1 / (alfaj + betaj);
                double infj = alfaj / (alfaj + betaj);
                double taud = 1 / (alfad + betad);
                double infd = alfad / (alfad + betad);
                double tauf = 1 / (alfaf + betaf);
                double inff = alfaf / (alfaf + betaf);
                double taux = 1 / (alfax + betax);
                double infx = alfax / (alfax + betax);
                double dm = (infm - m) / taum;
                double dh = (infh - h) / tauh;
                double dj = (infj - j) / tauj;
                double dd = (infd - d) / taud;
                double df = (inff - f) / tauf;
                double dx = (infx - x) / taux;
                if (i >= (double.Parse(textBox3.Text) * 100) && i <= ((double.Parse(textBox3.Text) + double.Parse(textBox2.Text)) * 100))
                {
                    U = double.Parse(to.Text);
                }
                else
                {
                    U = double.Parse(from.Text);
                }
                m = m + dt * dm;
                h = h + dt * dh;
                j = j + dt * dj;
                d = d + dt * dd;
                f = f + dt * df;
                x = x + dt * dx;
                alfam = 0.32 * (U + 47.13) / (1 - Math.Exp(-0.1 * (U + 47.13)));
                betam = 0.08 * Math.Exp(-U / 11.0);
                //alfah = 0.5 * (1 - Math.Sign(U + 40 + Math.Pow(2, -52))) * 0.135 * Math.Exp(-1.0 * (80 + U) / 6.8);
                //betah = (3.56 * Math.Exp(0.079 * U) + 3.1 * 1e5 * Math.Exp(0.35 * U)) * 0.5 * (1 - Math.Sign(U + 40 + Math.Pow(2, -52))) + (1 / (0.13 * (1 + Math.Exp(-1 * (U + 10.66) / 11.1)))) * 0.5 * (1 + Math.Sign(U + 40 + Math.Pow(2, -52)));
                if (U < -40)
                {
                    alfah = 0.135 * Math.Exp((80 + U) / (-6.8));
                    betah = 3.56 * Math.Exp(0.079 * U) + 3.1 * Math.Pow(10, 5) * Math.Exp(0.35 * U);
                    alfaj = (-1.2714 * 100000 * Math.Exp(0.2444 * U) - 3.474 * Math.Pow(10, -5) * Math.Exp(-0.04391 * U)) * (U + 37.78) / (1 + Math.Exp(0.311 * (U + 79.23)));
                    betaj = 0.1212 * Math.Exp(-0.01052 * U) / (1 + Math.Exp(-0.1378 * (U + 40.14)));
                }
                else
                {
                    alfah = 0;
                    betah = 1 / (0.13 * (1 + Math.Exp((U + 10.66) / -11.1)));
                    alfaj = 0;
                    betaj = 0.3 * Math.Exp(-2.535 * Math.Pow(10, -7) * U) / (1 + Math.Exp(-0.1 * (U + 32)));
                }
                //alfaj = 0.5 * (1 - Math.Sign(U + 40 + Math.Pow(2, -52))) * (-1.2714 * 1e5 * Math.Exp(0.2444 * U) - 3.474 * 1e-5 * Math.Exp(-0.04391 * U)) * (U + 37.78) / (1 + Math.Exp(0.311 * (U + 79.23)));
                //betaj = 0.5 * (1 - Math.Sign(U + 40 + Math.Pow(2, -52))) * 0.1212 * Math.Exp(-0.01052 * U) / (1 + Math.Exp(-0.1378 * (U + 40.14))) + 0.5 * (1 + Math.Sign(U + 40 + Math.Pow(2, -52))) * 0.3 * Math.Exp(-2.535 * 1e-7 * U) / (1 + Math.Exp(-0.1 * (U + 32)));
                alfad = 0.095 * Math.Exp(-0.01 * (U - 5)) / (1 + Math.Exp(-0.072 * (U - 5)));
                betad = 0.07 * Math.Exp(-0.017 * (U + 44)) / (1 + Math.Exp(0.05 * (U + 44)));
                alfaf = 0.012 * Math.Exp(-0.008 * (U + 28)) / (1 + Math.Exp(0.15 * (U + 28)));
                betaf = 0.0065 * Math.Exp(-0.02 * (U + 30)) / (1 + Math.Exp(-0.2 * (U + 30)));
                alfax = 0.0005 * Math.Exp(0.083 * (U + 50)) / (1 + Math.Exp(0.057 * (U + 50)));
                betax = 0.0013 * Math.Exp(-0.06 * (U + 20)) / (1 + Math.Exp(-0.04 * (U + 20)));
                alfak1 = 1.02 / (1 + Math.Exp(0.2385 * (U - EK1 - 59.2915)));
                betak1 = (0.49124 * Math.Exp(0.08032 * (U - EK1 + 5.476)) + Math.Exp(0.06175 * (U - EK1 - 594.31))) / (1 + Math.Exp(-0.5143 * (U - EK1 + 4.753)));
                graf.Series["Proud 1"].Points.AddXY(i / 100, INax);
                graf.Series["Proud 1"].Enabled = false;
                graf.Series["Proud 2"].Points.AddXY(i / 100, ICa);
                graf.Series["Proud 2"].Enabled = false;
                graf.Series["Proud 3"].Points.AddXY(i / 100, IK);
                graf.Series["Proud 3"].Enabled = false;
                graf.Series["Proud 4"].Points.AddXY(i / 100, Ibg);
                graf.Series["Proud 4"].Enabled = false;
                graf.Series["Proud 5"].Points.AddXY(i / 100, Ito);
                graf.Series["Proud 5"].Enabled = false;
                graf.Series["Proud 8"].Points.AddXY(i / 100, Imx);
                graf.Series["Proud 8"].Enabled = true;
                graf.Series["Proud 6"].Points.AddXY(i / 100, (If * 300) - 1);
                graf.Series["Proud 6"].Enabled = false;
                graf.Series["osy"].Points.AddXY(i / 100, 0);
                graf.Series["osy"].Enabled = true;
                double maxhod = Math.Max(INax, ICa);
                maxhod = Math.Max(maxhod, ICa);
                maxhod = Math.Max(maxhod, IK);
                maxhod = Math.Max(maxhod, Ibg);
                maxhod = Math.Max(maxhod, Ito);
                maxhod = Math.Max(maxhod, IK1);
                maxhod = Math.Max(maxhod, IKp);
                maxhod = Math.Max(maxhod, Imx);
                maxhod = Math.Ceiling(maxhod);
                double minhod = Math.Min(INax, ICa);
                minhod = Math.Min(minhod, ICa);
                minhod = Math.Min(minhod, IK);
                minhod = Math.Min(minhod, Ibg);
                minhod = Math.Min(minhod, Ito);
                minhod = Math.Min(minhod, IK1);
                minhod = Math.Min(minhod, IKp);
                minhod = Math.Min(minhod, Imx);
                minhod = Math.Floor(minhod);
                if (minhod % 2 != 0)
                {
                    minhod = minhod - 1;
                }
                if (maxhod % 2 != 0)
                {
                    maxhod = maxhod + 1;
                }
                if (pommax < maxhod)
                {
                    graf.ChartAreas["ChartArea1"].AxisY.Maximum = maxhod;
                    pommax = maxhod;
                }
                if (pommin > minhod)
                {
                    graf.ChartAreas["ChartArea1"].AxisY.Minimum = minhod;
                    pommin = minhod;
                }
                if (U % 20 == 0)
                {
                    U = U + 0.001;
                }
                graf.Series["Napeti 1"].Points.AddXY(i / 100, U);

                if (i >= (double.Parse(textBox3.Text) * 100) && i <= ((double.Parse(textBox3.Text) + double.Parse(textBox2.Text)) * 100))
                {
                    double pokusxx = dt * 0.1 * (3 * (pokusx + pokussy - ((pokusx * pokusx * pokusx) / 3) - 0.4)) + pokusx;
                    double pokusyy = dt * 0.1 * (-0.33333333 * (pokusx - 0.7 + 0.8 * pokussy)) + pokussy;
                    pokusx = pokusxx;
                    pokussy = pokusyy;
                }
                else
                {
                    pokusx = 0;
                }
                V = (pokusx - 1) * 20 * ((double.Parse(to.Text) - double.Parse(from.Text)) / 100);

            }
            progressBar1.Value = 0;
            progressBar2.Value = 0;
        }
        void vypocet2() //current clamp
        {
            if (setcurr.Checked == true)
            {
                if (double.Parse(timex.Text) > 1500)
                {
                    timex.Text = "1500";
                    MessageBox.Show("Max lenght of mesuring is 1500");
                }
            }
            progressBar1.Minimum = 0;
            progressBar1.Maximum = 3;
            progressBar2.Minimum = 0;
            progressBar2.Maximum = 3;
            progressBar1.Value = 1;
            progressBar2.Value = 1;
            graff.Series.Clear();
            progressBar1.Value = 2;
            progressBar2.Value = 2;
            graff.Series.Clear();
            progressBar1.Value = 3;
            progressBar2.Value = 3;
            double U = -83;
            graff.Series.Add("Proud 1");
            graff.Series["Proud 1"].ChartType = SeriesChartType.FastLine;
            graff.Series["Proud 1"].Color = Color.DarkSlateGray;
            graff.Series["Proud 1"].BorderWidth = 2;
            graff.Series.Add("osy");
            graff.Series["osy"].ChartType = SeriesChartType.FastLine;
            graff.Series["osy"].Color = Color.Transparent;
            graff.Series.Add("Napeti 1");
            graff.Series["Napeti 1"].ChartType = SeriesChartType.FastLine;
            graff.Series["Napeti 1"].Color = Color.DarkGreen;
            graff.Series["Napeti 1"].ChartArea = graff.ChartAreas[1].Name;
            graff.Series["Napeti 1"].BorderWidth = 2;
            graff.Series.Add("osy2");
            graff.Series["osy2"].ChartType = SeriesChartType.FastLine;
            graff.Series["osy2"].Color = Color.Transparent;
            graff.Series["osy2"].ChartArea = graff.ChartAreas[1].Name;
            graff.ChartAreas[0].AxisX.Title = "Time [ms]";
            graff.ChartAreas[0].AxisY.Title = "Current [mA]";
            graff.ChartAreas[1].AxisX.Title = "Time [ms]";
            graff.ChartAreas[1].AxisY.Title = "Voltage [mV]";
            double alfam = 0.32 * (U + 47.13) / (1 - Math.Exp(-0.1 * (U + 47.13)));
            double betam = 0.08 * Math.Exp(-U / 11.0);
            double alfah = 0.5 * (1 - Math.Sign(U + 40 + Math.Pow(2, -52))) * 0.135 * Math.Exp(-1 * (80 + U) / 6.8);
            double betah = (3.56 * Math.Exp(0.079 * U) + 3.1 * 1e5 * Math.Exp(0.35 * U)) * 0.5 * (1 - Math.Sign(U + 40 + Math.Pow(2, -52))) + (1 / (0.13 * (1 + Math.Exp(-1 * (U + 10.66) / 11.1)))) * 0.5 * (1 + Math.Sign(U + 40 + Math.Pow(2, -52)));
            double alfaj = 0.5 * (1 - Math.Sign(U + 40 + Math.Pow(2, -52))) * (-1.2714 * 1e5 * Math.Exp(0.2444 * U) - 3.474 * 1e-5 * Math.Exp(-0.04391 * U)) * (U + 37.78) / (1 + Math.Exp(0.311 * (U + 79.23)));
            double betaj = 0.5 * (1 - Math.Sign(U + 40 + Math.Pow(2, -52))) * 0.1212 * Math.Exp(-0.01052 * U) / (1 + Math.Exp(-0.1378 * (U + 40.14))) + 0.5 * (1 + Math.Sign(U + 40 + Math.Pow(2, -52))) * 0.3 * Math.Exp(-2.535 * 1 * Math.Exp(-7) * U) / (1 + Math.Exp(-0.1 * (U + 32)));
            double alfad = 0.095 * Math.Exp(-0.01 * (U - 5)) / (1 + Math.Exp(-0.072 * (U - 5)));
            double betad = 0.07 * Math.Exp(-0.017 * (U + 44)) / (1 + Math.Exp(0.05 * (U + 44)));
            double alfaf = 0.012 * Math.Exp(-0.008 * (U + 28)) / (1 + Math.Exp(0.15 * (U + 28)));
            double betaf = 0.0065 * Math.Exp(-0.02 * (U + 30)) / (1 + Math.Exp(-0.2 * (U + 30)));
            double alfax = 0.0005 * Math.Exp(0.083 * (U + 50)) / (1 + Math.Exp(0.057 * (U + 50)));
            double betax = 0.0013 * Math.Exp(-0.06 * (U + 20)) / (1 + Math.Exp(-0.04 * (U + 20)));
            double alfak1 = 1.02 / (1 + Math.Exp(0.2385 * (U - EK1 - 59.2915)));
            double betak1 = (0.49124 * Math.Exp(0.08032 * (U - EK1 + 5.476)) + Math.Exp(0.06175 * (U - EK1 - 594.31))) / (1 + Math.Exp(-0.5143 * (U - EK1 + 4.753)));
            double m = alfam / (alfam + betam);
            double h = alfah / (alfah + betah);
            double j = alfaj / (alfaj + betaj);
            double d = alfad / (alfad + betad);
            double f = alfaf / (alfaf + betaf);
            double x = alfax / (alfax + betax);
            double dt = 0.01;
            double pommax = 0;
            double pommin = 0;
            int bar = 0;
            int time = 0;
            double Time = 0;
            if (setcurr.Checked == true)
            {
                time = int.Parse(timex.Text);
                Time = double.Parse(timex.Text);
            };
            if (setcurr.Checked == false)
            {
                if (double.Parse(second.Text) == 0)
                {
                    time = 600;
                    Time = 600;
                }
                else
                {
                    time = int.Parse(second.Text) + 600;
                    Time = double.Parse(second.Text) + 600;
                }
            };
            progressBar1.Minimum = 0;
            progressBar1.Maximum = (time * 100);
            progressBar2.Minimum = 0;
            progressBar2.Maximum = (time * 100);
            for (double i = 0; i < (Time * 100); i++)
            {
                progressBar1.Value = bar;
                progressBar2.Value = bar;
                bar++;
                double xi = 0.5 * (1 + Math.Sign(U + 100 - (2.2204 * Math.Pow(10, -16)))) * 2.837 * (Math.Exp(0.04 * (U + 77)) - 1) / ((U + 77) * Math.Exp(0.04 * (U + 35))) + 0.5 * (1 - Math.Sign(U + 100 - (2.2204 * Math.Pow(10, -16))));
                double INa = (gNa * (Math.Pow(m, 3)) * h * j * (U - ENa));
                double INax = INa / 50;
                double ICa = gCa * d * f * (U - ECa);
                double IK = gK * x * xi * (U - EK);
                double IK1 = gK1 * (alfak1 / (alfak1 + betak1)) * (U - EK1);
                double IKp = 0.0183 * (U - EKp) / (1 + Math.Exp((7.488 - U) / 5.98));
                double Ibg = 0.03921 * (U + 59.87);
                double Ito = gto * m * h * Math.Exp(U / 300) * (U - EK);
                double Im = INa + ICa + IK + IK1 + IKp + Ibg + Ito;
                double Imx = INax + ICa + IK + IK1 + IKp + Ibg + Ito;
                double taum = 1 / (alfam + betam);
                double infm = alfam / (alfam + betam);
                double tauh = 1 / (alfah + betah);
                double infh = alfah / (alfah + betah);
                double tauj = 1 / (alfaj + betaj);
                double infj = alfaj / (alfaj + betaj);
                double taud = 1 / (alfad + betad);
                double infd = alfad / (alfad + betad);
                double tauf = 1 / (alfaf + betaf);
                double inff = alfaf / (alfaf + betaf);
                double taux = 1 / (alfax + betax);
                double infx = alfax / (alfax + betax);
                double dm = (infm - m) / taum;
                double dh = (infh - h) / tauh;
                double dj = (infj - j) / tauj;
                double dd = (infd - d) / taud;
                double df = (inff - f) / tauf;
                double dx = (infx - x) / taux;
                double Istym = 0;
                if (i == (double.Parse(first.Text) * 100))
                {
                    Istym = (-1) * double.Parse(curr.Text);
                }
                if (i == (double.Parse(second.Text) * 100))
                {
                    if (double.Parse(second.Text) == 0) { }
                    else
                    {
                        Istym = (-1) * double.Parse(curr.Text);
                    }
                }
                double dU = -Im - Istym;
                U = U + dt * dU;
                m = m + dt * dm;
                h = h + dt * dh;
                j = j + dt * dj;
                d = d + dt * dd;
                f = f + dt * df;
                x = x + dt * dx;
                alfam = 0.32 * (U + 47.13) / (1 - Math.Exp(-0.1 * (U + 47.13)));
                betam = 0.08 * Math.Exp(-U / 11.0);
                alfah = 0.5 * (1 - Math.Sign(U + 40 + Math.Pow(2, -52))) * 0.135 * Math.Exp(-1.0 * (80 + U) / 6.8);
                betah = (3.56 * Math.Exp(0.079 * U) + 3.1 * 1e5 * Math.Exp(0.35 * U)) * 0.5 * (1 - Math.Sign(U + 40 + Math.Pow(2, -52))) + (1 / (0.13 * (1 + Math.Exp(-1 * (U + 10.66) / 11.1)))) * 0.5 * (1 + Math.Sign(U + 40 + Math.Pow(2, -52)));
                alfaj = 0.5 * (1 - Math.Sign(U + 40 + Math.Pow(2, -52))) * (-1.2714 * 1e5 * Math.Exp(0.2444 * U) - 3.474 * 1e-5 * Math.Exp(-0.04391 * U)) * (U + 37.78) / (1 + Math.Exp(0.311 * (U + 79.23)));
                betaj = 0.5 * (1 - Math.Sign(U + 40 + Math.Pow(2, -52))) * 0.1212 * Math.Exp(-0.01052 * U) / (1 + Math.Exp(-0.1378 * (U + 40.14))) + 0.5 * (1 + Math.Sign(U + 40 + Math.Pow(2, -52))) * 0.3 * Math.Exp(-2.535 * 1e-7 * U) / (1 + Math.Exp(-0.1 * (U + 32)));
                alfad = 0.095 * Math.Exp(-0.01 * (U - 5)) / (1 + Math.Exp(-0.072 * (U - 5)));
                betad = 0.07 * Math.Exp(-0.017 * (U + 44)) / (1 + Math.Exp(0.05 * (U + 44)));
                alfaf = 0.012 * Math.Exp(-0.008 * (U + 28)) / (1 + Math.Exp(0.15 * (U + 28)));
                betaf = 0.0065 * Math.Exp(-0.02 * (U + 30)) / (1 + Math.Exp(-0.2 * (U + 30)));
                alfax = 0.0005 * Math.Exp(0.083 * (U + 50)) / (1 + Math.Exp(0.057 * (U + 50)));
                betax = 0.0013 * Math.Exp(-0.06 * (U + 20)) / (1 + Math.Exp(-0.04 * (U + 20)));
                alfak1 = 1.02 / (1 + Math.Exp(0.2385 * (U - EK1 - 59.2915)));
                betak1 = (0.49124 * Math.Exp(0.08032 * (U - EK1 + 5.476)) + Math.Exp(0.06175 * (U - EK1 - 594.31))) / (1 + Math.Exp(-0.5143 * (U - EK1 + 4.753)));
                double maxhod = Istym / 1000;
                double minhod = Istym / 1000;
                maxhod = Math.Ceiling(maxhod);
                minhod = Math.Floor(minhod);
                if (minhod % 2 != 0)
                {
                    minhod = minhod - 1;
                }
                if (maxhod % 2 != 0)
                {
                    maxhod = maxhod + 1;
                }
                graff.Series["Proud 1"].Points.AddXY(i / 100, -Istym / 1000);
                graff.Series["Proud 1"].Enabled = true;
                if (pommax < maxhod)
                {
                    graff.ChartAreas["ChartArea1"].AxisY.Maximum = maxhod;
                    pommax = maxhod;
                }
                if (pommin > minhod)
                {
                    graff.ChartAreas["ChartArea1"].AxisY.Minimum = minhod;
                    pommin = minhod;
                }
                graff.Series["Napeti 1"].Points.AddXY(i / 100, U);
            }
            progressBar1.Value = 0;
            progressBar2.Value = 0;
        }
        private void Form1_Load_1(object sender, EventArgs e) //load program
        {
            start okno = new start();
            okno.Show();
            Application.DoEvents();
            for (int poi = 0; poi == 0; poi++)
            {
                vypocet1();
                vypocet2();
                okno.Close();
            }
            richTextBox1.SelectedText = "I";
            richTextBox1.SelectionCharOffset = -5;
            richTextBox1.SelectionFont = richTextBox1.SelectionFont = new Font("Microsoft Sans Serif", 7, FontStyle.Regular);
            richTextBox1.SelectedText = "m";
            richTextBox2.SelectedText = "I";
            richTextBox2.SelectionCharOffset = -5;
            richTextBox2.SelectionFont = richTextBox1.SelectionFont = new Font("Microsoft Sans Serif", 7, FontStyle.Regular);
            richTextBox2.SelectedText = "Na";
            richTextBox3.SelectedText = "I";
            richTextBox3.SelectionCharOffset = -5;
            richTextBox3.SelectionFont = richTextBox1.SelectionFont = new Font("Microsoft Sans Serif", 7, FontStyle.Regular);
            richTextBox3.SelectedText = "Ca";
            richTextBox4.SelectedText = "I";
            richTextBox4.SelectionCharOffset = -5;
            richTextBox4.SelectionFont = richTextBox1.SelectionFont = new Font("Microsoft Sans Serif", 7, FontStyle.Regular);
            richTextBox4.SelectedText = "to";
            richTextBox5.SelectedText = "I";
            richTextBox5.SelectionCharOffset = -5;
            richTextBox5.SelectionFont = richTextBox1.SelectionFont = new Font("Microsoft Sans Serif", 7, FontStyle.Regular);
            richTextBox5.SelectedText = "bg";
            richTextBox6.SelectedText = "I";
            richTextBox6.SelectionCharOffset = -5;
            richTextBox6.SelectionFont = richTextBox1.SelectionFont = new Font("Microsoft Sans Serif", 7, FontStyle.Regular);
            richTextBox6.SelectedText = "K";
            richTextBox7.SelectedText = "I";
            richTextBox7.SelectionCharOffset = -5;
            richTextBox7.SelectionFont = richTextBox1.SelectionFont = new Font("Microsoft Sans Serif", 7, FontStyle.Regular);
            richTextBox7.SelectedText = "f";
            graf.ChartAreas[0].AxisX.ScaleView.Zoomable = true;
            graf.ChartAreas[0].AxisY.ScaleView.Zoomable = true;
            graf.ChartAreas[0].CursorX.AutoScroll = true;
            graf.ChartAreas[0].CursorY.AutoScroll = true;
            graf.ChartAreas[0].CursorX.IsUserSelectionEnabled = true;
            graf.ChartAreas[0].CursorY.IsUserSelectionEnabled = true;
            graff.ChartAreas[1].AxisX.ScaleView.Zoomable = true;
            graff.ChartAreas[1].AxisY.ScaleView.Zoomable = true;
            graff.ChartAreas[1].CursorX.AutoScroll = true;
            graff.ChartAreas[1].CursorY.AutoScroll = true;
            graff.ChartAreas[1].CursorX.IsUserSelectionEnabled = true;
            graff.ChartAreas[1].CursorY.IsUserSelectionEnabled = true;
        }
        private void prepocitej_Click(object sender, EventArgs e) //resolve current clamp
        {
            vypocet1();
            if (INa_.Checked == true)
            {
                graf.Series["Proud 1"].Enabled = true;
                graf.ResetAutoValues();
            };
            if (INa_.Checked == false)
            {
                graf.Series["Proud 1"].Enabled = false;
                graf.ResetAutoValues();
            };
            if (ICa_.Checked == true)
            {
                graf.Series["Proud 2"].Enabled = true;
                graf.ResetAutoValues();
            };
            if (ICa_.Checked == false)
            {
                graf.Series["Proud 2"].Enabled = false;
                graf.ResetAutoValues();
            };
            if (IK_.Checked == true)
            {
                graf.Series["Proud 3"].Enabled = true;
                graf.ResetAutoValues();
            };
            if (IK_.Checked == false)
            {
                graf.Series["Proud 3"].Enabled = false;
                graf.ResetAutoValues();
            };
            if (Ibg_.Checked == true)
            {
                graf.Series["Proud 4"].Enabled = true;
                graf.ResetAutoValues();
            };
            if (Ibg_.Checked == false)
            {
                graf.Series["Proud 4"].Enabled = false;
                graf.ResetAutoValues();
            };
            if (Ito_.Checked == true)
            {
                graf.Series["Proud 5"].Enabled = true;
                graf.ResetAutoValues();
            };
            if (Ito_.Checked == false)
            {
                graf.Series["Proud 5"].Enabled = false;
                graf.ResetAutoValues();
            };
            if (Im_.Checked == true)
            {
                graf.Series["Proud 8"].Enabled = true;
                graf.ResetAutoValues();
            };
            if (Im_.Checked == false)
            {
                graf.Series["Proud 8"].Enabled = false;
                graf.ResetAutoValues();
            };
            if (IF.Checked == true)
            {
                graf.Series["Proud 6"].Enabled = true;
                graf.ResetAutoValues();
            };
            if (IF.Checked == false)
            {
                graf.Series["Proud 6"].Enabled = false;
                graf.ResetAutoValues();
            };
        }
        private void resolveC_Click(object sender, EventArgs e) //resolve voltage clamp
        {
            vypocet2();
        }
        private void INa_CheckedChanged(object sender, EventArgs e)
        {
            if (INa_.Checked == true)
            {
                graf.Series["Proud 1"].Enabled = true;
                graf.ResetAutoValues();
            };
            if (INa_.Checked == false)
            {
                graf.Series["Proud 1"].Enabled = false;
                graf.ResetAutoValues();
            };
        }
        private void ICa_CheckedChanged(object sender, EventArgs e)
        {
            if (ICa_.Checked == true)
            {
                graf.Series["Proud 2"].Enabled = true;
                graf.ResetAutoValues();
            };
            if (ICa_.Checked == false)
            {
                graf.Series["Proud 2"].Enabled = false;
                graf.ResetAutoValues();
            };
        }
        private void IK_CheckedChanged(object sender, EventArgs e)
        {
            if (IK_.Checked == true)
            {
                graf.Series["Proud 3"].Enabled = true;
                graf.ResetAutoValues();
            };
            if (IK_.Checked == false)
            {
                graf.Series["Proud 3"].Enabled = false;
                graf.ResetAutoValues();
            };
        }
        private void Ibg_CheckedChanged(object sender, EventArgs e)
        {
            if (Ibg_.Checked == true)
            {
                graf.Series["Proud 4"].Enabled = true;
                graf.ResetAutoValues();
            };
            if (Ibg_.Checked == false)
            {
                graf.Series["Proud 4"].Enabled = false;
                graf.ResetAutoValues();
            };
        }
        private void Ito_CheckedChanged(object sender, EventArgs e)
        {
            if (Ito_.Checked == true)
            {
                graf.Series["Proud 5"].Enabled = true;
                graf.ResetAutoValues();
            };
            if (Ito_.Checked == false)
            {
                graf.Series["Proud 5"].Enabled = false;
                graf.ResetAutoValues();
            };
        }
        private void Im_CheckedChanged(object sender, EventArgs e)
        {
            if (Im_.Checked == true)
            {
                graf.Series["Proud 8"].Enabled = true;
                graf.ResetAutoValues();
            };
            if (Im_.Checked == false)
            {
                graf.Series["Proud 8"].Enabled = false;
                graf.ResetAutoValues();
            };
        }
        private void setcurr_CheckedChanged(object sender, EventArgs e)
        {
            if (setcurr.Checked == true)
            {
                timex.Enabled = true;
            };
            if (setcurr.Checked == false)
            {
                timex.Enabled = false;
            };
        }
        private void setvolt_CheckedChanged(object sender, EventArgs e)
        {
            if (setvolt.Checked == true)
            {
                timey.Enabled = true;
            };
            if (setvolt.Checked == false)
            {
                timey.Enabled = false;
            };
        }
        private void entercurr(object sender, KeyPressEventArgs e) //resolve current clamp if press enter
        {
            if (e.KeyChar == (char)Keys.Enter)
            {
                vypocet2();
            }
        }
        private void entervoltage(object sender, KeyPressEventArgs e) //resolve current clamp if press enter
        {
            if (e.KeyChar == (char)Keys.Enter)
            {
                vypocet1();
                if (INa_.Checked == true)
                {
                    graf.Series["Proud 1"].Enabled = true;
                    graf.ResetAutoValues();
                };
                if (INa_.Checked == false)
                {
                    graf.Series["Proud 1"].Enabled = false;
                    graf.ResetAutoValues();
                };
                if (ICa_.Checked == true)
                {
                    graf.Series["Proud 2"].Enabled = true;
                    graf.ResetAutoValues();
                };
                if (ICa_.Checked == false)
                {
                    graf.Series["Proud 2"].Enabled = false;
                    graf.ResetAutoValues();
                };
                if (IK_.Checked == true)
                {
                    graf.Series["Proud 3"].Enabled = true;
                    graf.ResetAutoValues();
                };
                if (IK_.Checked == false)
                {
                    graf.Series["Proud 3"].Enabled = false;
                    graf.ResetAutoValues();
                };
                if (Ibg_.Checked == true)
                {
                    graf.Series["Proud 4"].Enabled = true;
                    graf.ResetAutoValues();
                };
                if (Ibg_.Checked == false)
                {
                    graf.Series["Proud 4"].Enabled = false;
                    graf.ResetAutoValues();
                };
                if (Ito_.Checked == true)
                {
                    graf.Series["Proud 5"].Enabled = true;
                    graf.ResetAutoValues();
                };
                if (Ito_.Checked == false)
                {
                    graf.Series["Proud 5"].Enabled = false;
                    graf.ResetAutoValues();
                };
                if (Im_.Checked == true)
                {
                    graf.Series["Proud 8"].Enabled = true;
                    graf.ResetAutoValues();
                };
                if (Im_.Checked == false)
                {
                    graf.Series["Proud 8"].Enabled = false;
                    graf.ResetAutoValues();
                };
                if (IF.Checked == true)
                {
                    graf.Series["Proud 6"].Enabled = true;
                    graf.ResetAutoValues();
                };
                if (IF.Checked == false)
                {
                    graf.Series["Proud 6"].Enabled = false;
                    graf.ResetAutoValues();
                };
            }
        }
        private void button1_Click(object sender, System.EventArgs e) //save current clamp as image
        {
            SaveFileDialog saveFileDialog1 = new SaveFileDialog();
            saveFileDialog1.Filter = "PNG Image|*.png|JPG Image|*.jpg|Bitmap Image|*.bmp";
            saveFileDialog1.Title = "Save Graf as image";
            DialogResult res = saveFileDialog1.ShowDialog();
            if (res == DialogResult.Cancel)
            {
                return;
            }
            if (saveFileDialog1.FileName != "")
            {
                System.IO.FileStream fs = (System.IO.FileStream)saveFileDialog1.OpenFile();
                switch (saveFileDialog1.FilterIndex)
                {
                    case 1:
                        this.graff.SaveImage(fs, ChartImageFormat.Png);
                        break;
                    case 2:
                        this.graff.SaveImage(fs, ChartImageFormat.Jpeg);
                        break;
                    case 3:
                        this.graff.SaveImage(fs, ChartImageFormat.Bmp);
                        break;
                    default:
                        break;
                }
                fs.Close();
            }
        }
        private void button2_Click(object sender, EventArgs e) //reset zoom current clamp
        {
            graff.ChartAreas[1].AxisX.ScaleView.ZoomReset();
            graff.ChartAreas[1].AxisY.ScaleView.ZoomReset();
        }
        private void button3_Click(object sender, EventArgs e) //save voltage clamp as image
        {
            SaveFileDialog saveFileDialog2 = new SaveFileDialog();
            saveFileDialog2.Filter = "PNG Image|*.png|JPG Image|*.jpg|Bitmap Image|*.bmp";
            saveFileDialog2.Title = "Save Graf as image";
            DialogResult res = saveFileDialog2.ShowDialog();
            if (res == DialogResult.Cancel)
            {
                return;
            }
            if (saveFileDialog2.FileName != "")
            {
                System.IO.FileStream fs = (System.IO.FileStream)saveFileDialog2.OpenFile();
                switch (saveFileDialog2.FilterIndex)
                {
                    case 1:
                        this.graf.SaveImage(fs, ChartImageFormat.Png);
                        break;
                    case 2:
                        this.graf.SaveImage(fs, ChartImageFormat.Jpeg);
                        break;
                    case 3:
                        this.graf.SaveImage(fs, ChartImageFormat.Bmp);
                        break;
                    default:
                        break;
                }
                fs.Close();
            }
        }
        private void button4_Click(object sender, EventArgs e) //reset zoom current clamp
        {
            graf.ChartAreas[0].AxisX.ScaleView.ZoomReset();
            graf.ChartAreas[0].AxisY.ScaleView.ZoomReset();
        }
        private void IF_CheckedChanged(object sender, EventArgs e)
        {
            if (IF.Checked == true)
            {
                graf.Series["Proud 6"].Enabled = true;
                graf.ResetAutoValues();
            };
            if (IF.Checked == false)
            {
                graf.Series["Proud 6"].Enabled = false;
                graf.ResetAutoValues();
            };
        }
    }
}